/*
 * FASTHELP command for FreeDOS, by Dosius.
 * Version 4.00 (this version is the first in C!)
 * (C) 1998-2000 Dosius Software Co.
 *
 * This program is distributed under the terms of the GNU General Public
 * License.  You are free to redistribute and/or modify this program as long
 * as this message is kept.
 *
 */
#include <conio.h>
#include <ctype.h>
#include <dir.h>
#include <process.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char intcmd[44][9]={"ALIAS","BEEP","BREAK","CALL","CD","CDD","CHDIR","CLS",
"COPY","DATE","DEBUG","DEL","DIR","DIRS","ECHO","ERASE","EXIT","FOR","GOTO",
"IF","LH","LOADFIX","LOADHIGH","MD","MKDIR","PATH","PAUSE","POPD","PROMPT",
"PUSHD","RD","REM","REN","RENAME","RMDIR","SET","SHIFT","TIME","TRUENAME",
"TYPE","VER","VERIFY","VOL",""};

void main(int argc,char** argv)
{
struct text_info ti;
FILE* fhelp;
char* spat;
int lin;
char dlin[256];
char cmd[256];
if (!strcmp(argv[1],"/?")) {printf("Provides help information for FreeDOS commands.\n\nFASTHELP [command]\n\n  command - displays help information on that command.\n");return;}
spat=searchpath("doshelp.hlp");
if (!spat) {fprintf (stderr,"Help file could not be found.\n");return;}
fhelp=fopen(spat,"rt");
if (!fhelp) {fprintf (stderr,"Error opening help file.\n");return;}
if (argc>1) {
do {
fgets(dlin,255,fhelp);
if (feof(fhelp)) break; if (dlin[0]==64) continue;
if (!strnicmp(argv[1],dlin,strlen(argv[1])))
{
for (lin=0;lin<44;lin++) {
if (!strnicmp(argv[1],intcmd[lin],strlen(argv[1])))
{
     strcpy(cmd,intcmd[lin]);
     strcat(cmd," /?");
     system(cmd);
     return;
}
}
execlp(argv[1],"/?",0); /* mimic MS-DOS habit of ignoring extra text */
}
   } while (!feof(fhelp));
fprintf (stderr,"Help not available for this command.\n");
	return;
	}
gettextinfo(&ti);
lin=1;
	if (isatty(fileno(stdout)))
	printf ("\nFor more information on a specific command, type FASTHELP command-name.\n");
do {
fgets(dlin,255,fhelp);
if (feof(fhelp)) break; if (dlin[0]==64) continue;
if (lin>=(ti.screenheight-3) && (dlin[0]!=32) && isatty(fileno(stdout)))
	{
	printf ("-- More --");
	getch();
	printf ("\n\nFor more information on a specific command, type FASTHELP command-name.\n");
	lin=1;
	}
printf ("%s",dlin);
lin++;
   } while (!feof(fhelp));
fclose(fhelp);
}
